function WeaponImage::onReloadCheck(%this, %obj, %slot)
{
  if (%obj.getState() $= "Dead")
  {
    %obj.setImageAmmo(%slot, 0);
    return;
  }

  %obj.setImageAmmo(%slot, %obj.toolAmmo[%obj.currTool] < %this.item.maxAmmo);
}

function RaycastWeaponImage::onReloadCheck(%this, %obj, %slot)
{
  WeaponImage::onReloadCheck(%this, %obj, %slot);
}

function WeaponImage::onAmmoCheck(%this, %obj, %slot)
{
  if (%obj.getState() $= "Dead")
  {
    %obj.setImageAmmo(%slot, 0);
    return;
  }

  %obj.setImageAmmo(%slot, %obj.toolAmmo[%obj.currTool]);
}

function RaycastWeaponImage::onAmmoCheck(%this, %obj, %slot)
{
  WeaponImage::onAmmoCheck(%this, %obj, %slot);
}

package WeaponAmmoPackage
{
  function WeaponImage::onMount(%this, %obj, %slot)
  {
    Parent::onMount(%this, %obj, %slot);

    if (%this.item.maxAmmo !$= "" && (%obj.currTool == -1 || %obj.toolAmmo[%obj.currTool] $= ""))
    {
      %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
    }
  }

  function RaycastWeaponImage::onMount(%this, %obj, %slot)
  {
    Parent::onMount(%this, %obj, %slot);

    if (%this.item.maxAmmo !$= "" && (%obj.currTool == -1 || %obj.toolAmmo[%obj.currTool] $= ""))
    {
      %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
    }
  }

  function serverCmdLight(%client)
  {
    %player = %client.player;

    if (isObject(%player) && isObject(%player.getMountedImage(0)))
    {
      %image = %player.getMountedImage(0);

      if (%image.item.maxAmmo !$= "" && %image.item.canReload && %player.toolAmmo[%player.currTool] < %image.item.maxAmmo)
      {
        %state = %player.getImageState(0);

        if (%state $= "Ready" || %state $= "Empty")
        {
          %player.setImageAmmo(0, 0);
          %player.schedule(50 / getTimeScale(), setImageAmmo, 0, 1);
        }

        return;
      }
    }

    Parent::serverCmdLight(%client);
  }

  function serverCmdDropTool(%client, %slot)
  {
    %player = %client.player;

    if (isObject(%player) && %player.tool[%slot].maxAmmo !$= "")
    {
      $LoadedAmmo = %player.toolAmmo[%slot];
      %player.toolAmmo[%slot] = "";
    }

    Parent::serverCmdDropTool(%client, %slot);
    $LoadedAmmo = "";
  }

  function ItemData::onAdd(%this, %obj)
  {
    if ($LoadedAmmo !$= "")
    {
      %obj.loadedAmmo = $LoadedAmmo;
      $LoadedAmmo = "";
    }

    Parent::onAdd(%this, %obj);
  }

  function Player::pickup(%this, %item)
  {
    %data = %item.getDataBlock();
    %success = Parent::pickup(%this, %item);

    if (%success && %data.maxAmmo !$= "")
    {
      for (%i = %this.getDataBlock().maxTools - 1; %i >= 0; %i--)
      {
        if (%this.tool[%i] == %data && %this.toolAmmo[%i] $= "")
        {
          break;
        }
      }

      if (%i >= 0)
      {
        %this.toolAmmo[%i] = %item.loadedAmmo $= "" ? %data.maxAmmo : %item.loadedAmmo;
      }
    }

    return %success;
  }

  function AIPlayer::setImageTrigger(%this, %slot, %value)
  {
    Parent::setImageTrigger(%this, %slot, %value);
  }
};

activatePackage("WeaponAmmoPackage");