addDamageType("WesternColtNavy", '', '%2 <Colt Navy 1851> %1', 0.2, 1);
addDamageType("WesternColtNavyHead", '', '%2 <Colt Navy 1851> <hat> %1', 0.2, 1);

datablock AudioProfile(WesternColtNavyFireSound)
{
  fileName = "./sounds_new/weapons/coltnavy/fire.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtNavyCockSound1)
{
  fileName = "./sounds_new/weapons/coltnavy/cock1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtNavyCockSound2)
{
  fileName = "./sounds_new/weapons/coltnavy/cock2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtNavyOpenSound)
{
  fileName = "./sounds_new/weapons/coltnavy/open.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtNavyCloseSound)
{
  fileName = "./sounds_new/weapons/coltnavy/close.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtNavyInsertSound)
{
  fileName = "./sounds_new/weapons/coltnavy/insert.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtNavySpinSound)
{
  fileName = "./sounds_new/weapons/coltnavy/spin.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternColtNavyItem)
{
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  uiName = "Colt Navy 1851";
  image = WesternColtNavyImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;

  maxAmmo = 6;
  canReload = 1;
};

datablock ShapeBaseImageData(WesternColtNavyImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  item = WesternColtNavyItem;
  armReady = 1;

  range = 300;
  spread = 0.03;
  spreadMoving = 0.16;
  useSourceSpread = 1;

  directDamage = 37;
  directDamageType = $DamageType::WesternColtNavy;

  directHeadDamage = 74;
  directHeadDamageType = $DamageType::WesternColtNavyHead;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.75;
  stateTransitionOnTimeout[0] = "AmmoCheck";

  // Transitions to Ready with ImageAmmo set based on chamber
  stateName[1] = "AmmoCheck";
  stateScript[1] = "onAmmoCheck";
  stateTransitionOnTimeout[1] = "Ready";

  stateName[2] = "Ready";
  stateTransitionOnTriggerDown[2] = "Fire";
  stateTransitionOnNoAmmo[2] = "ReloadOpen";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.2;
  stateTransitionOnTimeout[3] = "Delay";
  stateEmitter[3] = WesternSmokeBurstEmitter;
  stateEmitterTime[3] = 0.3;
  stateEmitterNode[3] = "muzzleNode";

  stateName[4] = "Delay";
  stateTimeoutValue[4] = 0.9;
  stateTransitionOnTimeout[4] = "AmmoCheck";
  stateEmitter[4] = WesternSmokeTrailEmitter;
  stateEmitterTime[4] = 1.2;
  stateEmitterNode[4] = "muzzleNode";

  // Open the chamber
  stateName[5] = "ReloadOpen";
  stateScript[5] = "onReloadOpen";
  stateTimeoutValue[5] = 1;
  stateTransitionOnTimeout[5] = "ReloadCheck";

  // Check whether more bullets can be inserted
  stateName[6] = "ReloadCheck";
  stateScript[6] = "onReloadCheck";
  stateTimeoutValue[6] = 0.01;
  stateTransitionOnTimeout[6] = "ReloadCheckResult";

  // Either insert another bullet or close the chamber
  stateName[7] = "ReloadCheckResult";
  stateTimeoutValue[7] = 0.01;
  stateWaitForTimeout[7] = 1;
  stateTransitionOnAmmo[7] = "ReloadInsert";
  stateTransitionOnNoAmmo[7] = "ReloadClose";

  // Insert a bullet and then check again
  stateName[8] = "ReloadInsert";
  stateScript[8] = "onReloadInsert";
  stateTimeoutValue[8] = 0.7;
  stateTransitionOnTimeout[8] = "ReloadCheck";

  // No more bullets can fit, close chamber, then spin+cock
  stateName[9] = "ReloadClose";
  stateScript[9] = "onReloadClose";
  stateTimeoutValue[9] = 0.21;
  stateTransitionOnTimeout[9] = "ReloadSpin";

  // Gotta be fancy.
  stateName[10] = "ReloadSpin";
  stateScript[10] = "onReloadSpin";
  stateTimeoutValue[10] = 0.85;
  stateTransitionOnTimeout[10] = "ReloadCock";

  stateName[11] = "ReloadCock";
  stateScript[11] = "onReloadCock";
  stateTimeoutValue[11] = 0.3;
  stateTransitionOnTimeout[11] = "AmmoCheck";
};

datablock ShapeBaseImageData(WesternColtNavyFanningImage : WesternColtNavyImage)
{
  eyeOffset = "0.15 0.6 -0.5";

  range = 300;
  spread = 2.8624;

  stateSound[0] = "";
  stateTimeoutValue[0] = 0;

  stateTransitionOnNoAmmo[2] = "Empty";

  stateAllowImageChange[3] = 0;

  stateTimeoutValue[4] = 0.225;
  stateAllowImageChange[4] = 0;

  stateName[12] = "Empty";
  stateScript[12] = "onEmpty";
};

function WesternColtNavyImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  %obj.setWesternSpeed(3);
  %obj.updateAmmoDisplay();
}

function WesternColtNavyImage::onUnMount(%this, %obj, %slot)
{
  Parent::onUnMount(%this, %obj, %slot);

  %obj.setWesternSpeed(0);
  %obj.updateAmmoDisplay();
}

function WesternColtNavyImage::onReloadOpen(%this, %obj, %slot)
{
  %obj.schedule(100, "playThread", 2, "shiftLeft");
  %obj.setWesternSpeed(6);

  serverPlay3D(WesternColtNavyOpenSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtNavyImage::onReloadInsert(%this, %obj, %slot)
{
  %obj.playThread(2, "plant");

  %obj.toolAmmo[%obj.currTool]++;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternColtNavyInsertSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtNavyImage::onReloadClose(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftRight");
  serverPlay3D(WesternColtNavyCloseSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtNavyImage::onReloadSpin(%this, %obj, %slot)
{
  %obj.playThread(2, "rotCCW");
  serverPlay3D(WesternColtNavySpinSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtNavyImage::onReloadCock(%this, %obj, %slot)
{
  //%obj.playThread(2, "plant");
  %obj.setWesternSpeed(3);
  serverPlay3D(WesternColtNavyCockSound @ getRandom(1, 2), %obj.getMuzzlePoint(%slot));
}

function WesternColtNavyImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);
  %obj.playThread(2, "activate");

  %obj.toolAmmo[%obj.currTool]--;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternColtNavyFireSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtNavyImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage + getRandom(-5, 5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

function WesternColtNavyFanningImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  %obj.setWesternSpeed(5);
  %obj.updateAmmoDisplay();
}

function WesternColtNavyFanningImage::onUnMount(%this, %obj, %slot)
{
  %obj.setWesternSpeed(0);
  Parent::onUnMount(%this, %obj, %slot);
}

function WesternColtNavyFanningImage::onEmpty(%this, %obj, %slot)
{
  %obj.mountImage(WesternColtNavyImage, %slot);
}

function WesternColtNavyFanningImage::onFire(%this, %obj, %slot)
{
  WesternColtNavyImage::onFire(%this, %obj, %slot);
}

function WesternColtNavyFanningImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  WesternColtNavyImage::damage(%this, %obj, %col, %pos, %normal, %vector);
}

package WesternColtNavyPackage
{
  function Armor::onTrigger(%this, %obj, %slot, %state)
  {
    Parent::onTrigger(%this, %obj, %slot, %state);

    if (%slot != 4)
    {
      return;
    }

    if (%obj.toolAmmo[%obj.currTool] < 1)
    {
      return;
    }

    %mount = %obj.getMountedImage(0);

    %a = nameToID("WesternColtNavyImage");
    %b = nameToID("WesternColtNavyFanningImage");

    if (%mount == %a && %state)
    {
      %obj.mountImage(%b, 0);
    }
    else if (%mount == %b && !%state)
    {
      %obj.mountImage(%a, 0);
    }
  }
};

activatePackage("WesternColtNavyPackage");