addDamageType("WesternColtWalker", '', '%2 <Colt Walker> %1', 0.2, 1);
addDamageType("WesternColtWalkerHead", '', '%2 <Colt Walker> <hat> %1', 0.2, 1);

datablock AudioProfile(WesternColtWalkerFireSound)
{
  fileName = "./sounds_new/weapons/coltwalker/fire.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtWalkerCockSound)
{
  fileName = "./sounds_new/weapons/coltwalker/cock.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtWalkerInsertSound)
{
  fileName = "./sounds_new/weapons/coltwalker/insert.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternColtWalkerLeverSound)
{
  fileName = "./sounds_new/weapons/coltwalker/lever.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternColtWalkerItem)
{
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  uiName = "Colt Walker";
  image = WesternColtWalkerImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;

  maxAmmo = 6;
  canReload = 1;
};

datablock ShapeBaseImageData(WesternColtWalkerImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  item = WesternColtWalkerItem;
  armReady = 1;

  range = 300;
  spread = 0.038;
  spreadMoving = 0.18;
  useSourceSpread = 1;

  directDamage = 70;
  directDamageType = $DamageType::WesternColtWalker;

  directHeadDamage = 140;
  directHeadDamageType = $DamageType::WesternColtWalkerHead;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.6;
  stateTransitionOnTimeout[0] = "Cock";

  // Transitions to Ready with ImageAmmo set based on chamber
  stateName[1] = "AmmoCheck";
  stateScript[1] = "onAmmoCheck";
  stateTransitionOnTimeout[1] = "Ready";

  stateName[2] = "Ready";
  stateTransitionOnTriggerDown[2] = "Fire";
  stateTransitionOnNoAmmo[2] = "ReloadOpen";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.8;
  stateTransitionOnTimeout[3] = "Cock";
  stateEmitter[3] = WesternSmokeBurstEmitter;
  stateEmitterTime[3] = 0.3;
  stateEmitterNode[3] = "muzzleNode";

  stateName[4] = "Cock";
  stateScript[4] = "onCock";
  stateTimeoutValue[4] = 0.6;
  stateTransitionOnTimeout[4] = "AmmoCheck";

  // Open the chamber
  stateName[5] = "ReloadOpen";
  stateScript[5] = "onReloadOpen";
  stateTimeoutValue[5] = 0.9;
  stateTransitionOnTimeout[5] = "ReloadCheck";

  // Check whether more bullets can be inserted
  stateName[6] = "ReloadCheck";
  stateScript[6] = "onReloadCheck";
  stateTimeoutValue[6] = 0.01;
  stateTransitionOnTimeout[6] = "ReloadCheckResult";

  // Either insert another bullet or close the chamber
  stateName[7] = "ReloadCheckResult";
  stateTimeoutValue[7] = 0.01;
  stateWaitForTimeout[7] = 1;
  stateTransitionOnAmmo[7] = "ReloadInsert";
  stateTransitionOnNoAmmo[7] = "Cock";

  // Insert a bullet and then check again
  stateName[8] = "ReloadInsert";
  stateScript[8] = "onReloadInsert";
  stateTimeoutValue[8] = 0.75;
  stateTransitionOnTimeout[8] = "ReloadLever";

  stateName[9] = "ReloadLever";
  stateScript[9] = "onReloadLever";
  stateTimeoutValue[9] = 1;
  stateTransitionOnTimeout[9] = "ReloadCheck";
};

function WesternColtWalkerImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  %obj.setWesternSpeed(4);
  %obj.updateAmmoDisplay();
}

function WesternColtWalkerImage::onUnMount(%this, %obj, %slot)
{
  Parent::onUnMount(%this, %obj, %slot);

  %obj.setWesternSpeed(0);
  %obj.updateAmmoDisplay();
}

function WesternColtWalkerImage::onReloadOpen(%this, %obj, %slot)
{
  %obj.schedule(100, "playThread", 2, "plant");
  %obj.setWesternSpeed(6);

  serverPlay3D(WesternColtWalkerCockSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtWalkerImage::onReloadInsert(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftLeft");
  serverPlay3D(WesternColtWalkerInsertSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtWalkerImage::onReloadLever(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftRight");

  %obj.toolAmmo[%obj.currTool]++;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternColtWalkerLeverSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtWalkerImage::onReloadSpin(%this, %obj, %slot)
{
  %obj.playThread(2, "rotCCW");
  serverPlay3D(WesternColtWalkerSpinSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtWalkerImage::onCock(%this, %obj, %slot)
{
  %obj.schedule(100, "playThread", 2, "plant");
  %obj.setWesternSpeed(4);

  serverPlay3D(WesternColtWalkerCockSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtWalkerImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);
  %obj.playThread(2, "activate");

  %obj.toolAmmo[%obj.currTool]--;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternColtWalkerFireSound, %obj.getMuzzlePoint(%slot));
}

function WesternColtWalkerImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage + getRandom(-5, 5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}