addDamageType("WesternFists", '', '%2 <Fists> %1', 0.2, 1);
addDamageType("WesternFistsHead", '', '%2 <Fists> <head> %1', 0.2, 1);

datablock AudioProfile(WesternFistsMissSound1)
{
  fileName = "./sounds_new/weapons/fists/miss1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternFistsMissSound2)
{
  fileName = "./sounds_new/weapons/fists/miss2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternFistsMissSound3)
{
  fileName = "./sounds_new/weapons/fists/miss3.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternFistsMissSound4)
{
  fileName = "./sounds_new/weapons/fists/miss4.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternFistsPunchSound1)
{
  fileName = "./sounds_new/weapons/fists/punch1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternFistsPunchSound2)
{
  fileName = "./sounds_new/weapons/fists/punch2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternFistsPunchSound3)
{
  fileName = "./sounds_new/weapons/fists/punch3.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternFistsPunchSound4)
{
  fileName = "./sounds_new/weapons/fists/punch4.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternFistsItem)
{
  shapeFile = "./shapes/hand_right.dts";

  uiName = "Fists";
  image = WesternFistsImage;

  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;
};

datablock ShapeBaseImageData(WesternFistsLeftImage)
{
  shapeFile = "./shapes/hand_left.dts";

  mountPoint = 1;
  offset = "0 0.2 0";

  doColorShift = 1;
  colorShiftColor = "1.0 0.878 0.612 1.0";
};

datablock ShapeBaseImageData(WesternFistsImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "./shapes/hand_right.dts";

  mountPoint = 0;
  offset = "0 0.2 0";

  doColorShift = 1;
  colorShiftColor = "1.0 0.878 0.612 1.0";

  item = WesternFistsItem;
  canDrop = 0;

  melee = 1;
  range = 3;

  directDamage = 5;
  directDamageType = $DamageType::WesternFists;

  directHeadDamage = 10;
  directHeadDamageType = $DamageType::WesternFistsHead;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.75;
  stateTransitionOnTimeout[0] = "Ready";

  stateName[1] = "Ready";
  stateTransitionOnAmmo[1] = "PreSmack";
  stateTransitionOnTriggerDown[1] = "PreFire";

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateTimeoutValue[2] = 0.2;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.1;
  stateTransitionOnTimeout[3] = "PostFire";

  stateName[4] = "PostFire";
  stateScript[4] = "onPostFire";
  stateTimeoutValue[4] = 0.7;
  stateTransitionOnTimeout[4] = "Ready";

  stateName[5] = "PreSmack";
  stateScript[5] = "onPreSmack";
  stateTimeoutValue[5] = 0.5;
  stateAllowImageChange[5] = 0;
  stateTransitionOnTimeout[5] = "Smack";

  stateName[6] = "Smack";
  stateScript[6] = "onSmack";
  stateTimeoutValue[6] = 0.5;
  stateTransitionOnTimeout[6] = "Ready";
};

function WesternFistsImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  %obj.setWesternSpeed(0);
  %obj.setImageAmmo(%slot, 0);

  %obj.mountImage(WesternFistsLeftImage, 1);
  %obj.playThread(1, "armReadyBoth");
}

function WesternFistsImage::onUnMount(%this, %obj, %slot)
{
  if (%obj.getMountedImage(1) == nameToID("WesternFistsLeftImage"))
  {
    %obj.unMountImage(1);
  }

  Parent::onUnMount(%this, %obj, %slot);
}

function WesternFistsImage::onPreFire(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftRight");
}

function WesternFistsImage::onPostFire(%this, %obj, %slot)
{
}

function WesternFistsImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);
  %obj.playThread(2, "leftRecoil");
}

function WesternFistsImage::onPreSmack(%this, %obj, %slot)
{
  %obj.playThread(2, "spearReady");
}

function WesternFistsImage::onSmack(%this, %obj, %slot)
{
  // Get rid of this horrible badness immediately.
  %this.directDamage = 15;
  %this.directHeadDamage = 30;

  Parent::onFire(%this, %obj, %slot);

  %this.directDamage = 5;
  %this.directHeadDamage = 10;

  %obj.playThread(2, "spearThrow");
}

function WesternFistsImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage + getRandom(5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

function WesternFistsImage::onHitObject(%this, %obj, %col, %pos, %normal, %vector)
{
  Parent::onHitObject(%this, %obj, %col, %pos, %normal, %vector);
  serverPlay3D(WesternFistsPunchSound @ getRandom(1, 4), %pos);
}

function WesternFistsImage::onMiss(%this, %obj, %pos, %vector)
{
  Parent::onMiss(%this, %obj, %pos, %vector);
  serverPlay3D(WesternFistsMissSound @ getRandom(1, 4), %obj.getMuzzlePoint(0));
}

package WesternFistsPackage
{
  function Armor::onTrigger(%this, %obj, %slot, %state)
  {
    Parent::onTrigger(%this, %obj, %slot, %state);

    if (%slot != 4)
    {
      return;
    }

    if (%obj.tool[%obj.currTool] != nameToID("WesternFistsItem"))
    {
      return;
    }

    if (%obj.getMountedImage(0) != nameToID("WesternFistsImage"))
    {
      return;
    }

    %obj.setImageAmmo(0, %state);
  }
};

activatePackage("WesternFistsPackage");