addDamageType("WesternHatchet", '', '%2 <Hatchet> %1', 0.2, 1);
addDamageType("WesternHatchetHead", '', '%2 <Hatchet> <hat> %1', 0.2, 1);
addDamageType("WesternHatchetThrow", '', '%2 <thrown Hatchet> %1', 0.2, 1);

datablock AudioProfile(WesternHatchetThrowSound)
{
  fileName = "./sounds_new/weapons/hatchet/throw.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternHatchetSwingSound)
{
  fileName = "./sounds_new/weapons/hatchet/swing.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternHatchetHitWorldSound)
{
  fileName = "./sounds_new/weapons/hatchet/hit_world.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternHatchetHitSound1)
{
  fileName = "./sounds_new/weapons/hatchet/hit1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternHatchetHitSound2)
{
  fileName = "./sounds_new/weapons/hatchet/hit2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternHatchetHitSound3)
{
  fileName = "./sounds_new/weapons/hatchet/hit3.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternHatchetItem)
{
  shapeFile = "Add-Ons/Weapon_Sword/sword.dts";

  uiName = "Hatchet";
  image = WesternHatchetImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 1;
  sticky = 1;

  maxAmmo = 1;
  hideAmmo = 1;
  canReload = 0;
};

datablock ProjectileData(WesternHatchetProjectile)
{
  projectileShapeName = "Add-Ons/Weapon_Sword/sword.dts";

  isBallistic = 1;
  gravityMod = 1;
  bounceElasticity = 0;
  bounceFriction = 0;

  armingDelay = 0;
  lifeTime = 10000;
  fadeDelay = 19500;

  muzzleVelocity = 36;
  velInheritFactor = 1;

  directDamage = 65;
  directDamageType = $DamageType::WesternHatchetThrow;

  directHeadDamage = 85;
  directHeadDamageType = $DamageType::WesternHatchetThrow;
};

datablock ShapeBaseImageData(WesternHatchetImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Sword/sword.dts";

  item = WesternHatchetItem;
  armReady = 1;

  projectile = WesternHatchetProjectile;
  projectileType = Projectile;

  melee = 1;
  range = 2.75;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  directDamage = 40;
  directDamageType = $DamageType::WesternHatchet;

  directHeadDamage = 56;
  directHeadDamageType = $DamageType::WesternHatchetHead;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.75;
  stateTransitionOnTimeout[0] = "Ready";

  stateName[1] = "Ready";
  stateTransitionOnAmmo[1] = "PreThrow";
  stateTransitionOnTriggerDown[1] = "PreFire";

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateTimeoutValue[2] = 0.2;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.1;
  stateTransitionOnTimeout[3] = "PostFire";

  stateName[4] = "PostFire";
  stateScript[4] = "onPostFire";
  stateTimeoutValue[4] = 0.7;
  stateTransitionOnTimeout[4] = "Ready";

  stateName[5] = "PreThrow";
  stateScript[5] = "onPreThrow";
  stateTimeoutValue[5] = 0.25;
  stateAllowImageChange[5] = 0;
  stateTransitionOnTimeout[5] = "Throw";

  stateName[6] = "Throw";
  stateScript[6] = "onThrow";
  stateAllowImageChange[6] = 1;
  // stateTransitionOnNoAmmo[6] = "Ready";
};

function WesternHatchetImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  if (%obj.toolAmmo[%obj.currTool] < 1)
  {
    %obj.toolAmmo[%obj.currTool] = 1;
  }

  %obj.setWesternSpeed(0);
  %obj.setImageAmmo(%slot, 0);
}

function WesternHatchetImage::onUnMount(%this, %obj, %slot)
{
  Parent::onUnMount(%this, %obj, %slot);
}

function WesternHatchetImage::onPreFire(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftLeft");
}

function WesternHatchetImage::onPostFire(%this, %obj, %slot)
{
}

function WesternHatchetImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);

  %obj.playThread(2, "activate");
  serverPlay3D(WesternHatchetSwingSound, %obj.getMuzzlePoint(%slot));
}

function WesternHatchetImage::onPreThrow(%this, %obj, %slot)
{
  %obj.playThread(2, "spearReady");
}

function WesternHatchetImage::onThrow(%this, %obj, %slot)
{
  WeaponImage::onFire(%this, %obj, %slot);
  serverPlay3D(WesternHatchetThrowSound, %obj.getMuzzlePoint(%slot));

  %obj.playThread(2, "spearThrow");
  %obj.toolAmmo[%obj.currTool]--;

  if (%obj.toolAmmo[%obj.currTool] < 1)
  {
    %obj.tool[%obj.currTool] = 0;

    if (isObject(%obj.client))
    {
      messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0, 1);
    }

    %obj.schedule(32, "unMountImage", %slot);
    schedule(32, 0, "fixArmReady", %obj);
  }
  else
  {
    %obj.schedule(32, "unMountImage", %slot);
    %obj.schedule(32, "mountImage", %this, %slot);
  }
}

function WesternHatchetImage::onHitObject(%this, %obj, %col, %pos, %normal, %vector)
{
  Parent::onHitObject(%this, %obj, %col, %pos, %normal, %vector);
  
  if (%col.getType() & $TypeMasks::PlayerObjectType)
  {
    serverPlay3D(WesternHatchetHitSound @ getRandom(1, 3), %pos);
  }
  else
  {
    serverPlay3D(WesternHatchetHitWorldSound, %pos);
  }
}

function WesternHatchetImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage + getRandom(-5, 5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

function WesternHatchetProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
  %item = new Item()
  {
    dataBlock = WesternHatchetItem;
    miniGame = %obj.client.miniGame;
  };

  MissionCleanup.add(%item);

  %item.setTransform(vectorAdd(%pos, vectorScale(%normal, 0.25)));
  %item.setVelocity(vectorScale(%velocity, 0.25));

  %item.schedulePop();

  if (isObject(%col) && (%col.getType() & $TypeMasks::PlayerObjectType))
  {
    %item.setCollisionTimeout(%col);
  }

  if (%col.getType() & $TypeMasks::PlayerObjectType)
  {
    serverPlay3D(WesternHatchetHitSound @ getRandom(1, 3), %pos);
  }
  else
  {
    serverPlay3D(WesternHatchetHitWorldSound, %pos);
  }

  Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
}

function WesternHatchetProjectile::damage(%this, %obj, %col, %fade, %pos, %normal)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage + getRandom(-5, 5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

package WesternHatchetPackage
{
  function Armor::onCollision(%this, %obj, %col, %vector, %speed)
  {
    if (%col.getClassName() $= "Item" && %col.canPickup && %col.getDataBlock() == nameToID("WesternHatchetItem"))
    {
      for (%i = 0; %i < %this.maxTools; %i++)
      {
        if (%obj.tool[%i] == nameToID("WesternHatchetItem") && %obj.toolAmmo[%i] < 2)
        {
          %obj.toolAmmo[%i]++;

          if (%col.isStatic())
          {
            %col.respawn();
          }
          else
          {
            %col.delete();
          }

          return;
        }
      }
    }

    Parent::onCollision(%this, %obj, %col, %vector, %speed);
  }

  function Armor::onTrigger(%this, %obj, %slot, %state)
  {
    Parent::onTrigger(%this, %obj, %slot, %state);

    if (%slot != 4)
    {
      return;
    }

    if (%obj.tool[%obj.currTool] != nameToID("WesternHatchetItem"))
    {
      return;
    }

    if (%obj.getMountedImage(0) != nameToID("WesternHatchetImage"))
    {
      return;
    }

    %obj.setImageAmmo(0, %state);
  }
};

activatePackage("WesternHatchetPackage");