addDamageType("WesternKnife", '', '%2 <Knife> %1', 0.2, 1);
addDamageType("WesternKnifeHead", '', '%2 <Knife> <hat> %1', 0.2, 1);
addDamageType("WesternKnifeThrow", '', '%2 <thrown Knife> %1', 0.2, 1);

datablock AudioProfile(WesternKnifeThrowSound)
{
  fileName = "./sounds_new/weapons/knife/throw.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternKnifeSwingSound)
{
  fileName = "./sounds_new/weapons/knife/swing.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternKnifeHitWorldSound)
{
  fileName = "./sounds_new/weapons/knife/hit_world.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternKnifeStabSound1)
{
  fileName = "./sounds_new/weapons/knife/stab1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternKnifeStabSound2)
{
  fileName = "./sounds_new/weapons/knife/stab2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternKnifeStabSound3)
{
  fileName = "./sounds_new/weapons/knife/stab3.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternKnifeItem)
{
  shapeFile = "Add-Ons/Weapon_Sword/sword.dts";
  scale = "0.4 0.4 0.4";

  uiName = "Knife";
  image = WesternKnifeImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 1;
  sticky = 1;

  maxAmmo = 3;
  hideAmmo = 1;
  canReload = 0;
};

datablock ProjectileData(WesternKnifeProjectile)
{
  projectileShapeName = "Add-Ons/Weapon_Sword/sword.dts";

  isBallistic = 1;
  gravityMod = 0.6;
  bounceElasticity = 0;
  bounceFriction = 0;

  armingDelay = 0;
  lifeTime = 10000;
  fadeDelay = 19500;

  muzzleVelocity = 24;
  velInheritFactor = 1;

  directDamage = 43;
  directDamageType = $DamageType::WesternKnifeThrow;

  directHeadDamage = 54;
  directHeadDamageType = $DamageType::WesternKnifeThrow;
};

datablock ShapeBaseImageData(WesternKnifeImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Sword/sword.dts";

  item = WesternKnifeItem;
  armReady = 1;

  projectile = WesternKnifeProjectile;
  projectileType = Projectile;

  melee = 1;
  range = 2.75;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  directDamage = 30;
  directDamageType = $DamageType::WesternKnife;

  directHeadDamage = 42;
  directHeadDamageType = $DamageType::WesternKnifeHead;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.75;
  stateTransitionOnTimeout[0] = "Ready";

  stateName[1] = "Ready";
  stateTransitionOnAmmo[1] = "PreThrow";
  stateTransitionOnTriggerDown[1] = "PreFire";

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateTimeoutValue[2] = 0.2;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.1;
  stateTransitionOnTimeout[3] = "PostFire";

  stateName[4] = "PostFire";
  stateScript[4] = "onPostFire";
  stateTimeoutValue[4] = 0.45;
  stateTransitionOnTimeout[4] = "Ready";

  stateName[5] = "PreThrow";
  stateScript[5] = "onPreThrow";
  stateTimeoutValue[5] = 0.25;
  stateAllowImageChange[5] = 0;
  stateTransitionOnTimeout[5] = "Throw";

  stateName[6] = "Throw";
  stateScript[6] = "onThrow";
  stateAllowImageChange[6] = 1;
  // stateTransitionOnNoAmmo[6] = "Ready";
};

function WesternKnifeItem::onAdd(%this, %obj)
{
  Parent::onAdd(%this, %obj);

  %obj.setScale("0.4 0.4 0.4");
  %obj.loadedAmmo = 3;
}

function WesternKnifeImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  if (%obj.toolAmmo[%obj.currTool] < 1)
  {
    %obj.toolAmmo[%obj.currTool] = 1;
  }

  %obj.setWesternSpeed(0);
  %obj.setImageAmmo(%slot, 0);
}

function WesternKnifeImage::onUnMount(%this, %obj, %slot)
{
  Parent::onUnMount(%this, %obj, %slot);
}

function WesternKnifeImage::onPreFire(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftLeft");
}

function WesternKnifeImage::onPostFire(%this, %obj, %slot)
{
}

function WesternKnifeImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);

  %obj.playThread(2, "shiftTo");
  serverPlay3D(WesternKnifeSwingSound, %obj.getMuzzlePoint(%slot));
}

function WesternKnifeImage::onPreThrow(%this, %obj, %slot)
{
  %obj.playThread(2, "spearReady");
}

function WesternKnifeImage::onThrow(%this, %obj, %slot)
{
  %proj = WeaponImage::onFire(%this, %obj, %slot);

  if (isObject(%proj))
  {
    %proj.setScale("0.4 0.4 0.4");
  }

  serverPlay3D(WesternKnifeThrowSound, %obj.getMuzzlePoint(%slot));

  %obj.playThread(2, "spearThrow");
  %obj.toolAmmo[%obj.currTool]--;

  if (%obj.toolAmmo[%obj.currTool] < 1)
  {
    %obj.tool[%obj.currTool] = 0;

    if (isObject(%obj.client))
    {
      messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0, 1);
    }

    %obj.schedule(32, "unMountImage", %slot);
    schedule(32, 0, "fixArmReady", %obj);
  }
  else
  {
    %obj.schedule(32, "unMountImage", %slot);
    %obj.schedule(32, "mountImage", %this, %slot);
  }
}

function WesternKnifeImage::onHitObject(%this, %obj, %col, %pos, %normal, %vector)
{
  Parent::onHitObject(%this, %obj, %col, %pos, %normal, %vector);
  
  if (%col.getType() & $TypeMasks::PlayerObjectType)
  {
    serverPlay3D(WesternKnifeStabSound @ getRandom(1, 3), %pos);
  }
  else
  {
    serverPlay3D(WesternKnifeHitWorldSound, %pos);
  }
}

function WesternKnifeImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  if (%col.getType() & $TypeMasks::PlayerObjectType)
  {
    serverPlay3D(WesternKnifeStabSound @ getRandom(1, 3), %pos);
  }
  else
  {
    serverPlay3D(WesternKnifeHitWorldSound, %pos);
  }

  %col.damage(%obj, %pos, %damage + getRandom(-5, 5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

function WesternKnifeProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
  %item = new Item()
  {
    dataBlock = WesternKnifeItem;
    miniGame = %obj.client.miniGame;
  };

  MissionCleanup.add(%item);

  %item.setTransform(vectorAdd(%pos, vectorScale(%normal, 0.25)));
  %item.setVelocity(vectorScale(%velocity, 0.25));

  %item.schedulePop();

  if (isObject(%col) && (%col.getType() & $TypeMasks::PlayerObjectType))
  {
    %item.setCollisionTimeout(%col);
  }

  if (%col.getType() & $TypeMasks::PlayerObjectType)
  {
    serverPlay3D(WesternKnifeStabSound @ getRandom(1, 3), %pos);
  }
  else
  {
    serverPlay3D(WesternKnifeHitWorldSound, %pos);
  }

  Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
}

function WesternKnifeProjectile::damage(%this, %obj, %col, %fade, %pos, %normal)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage, %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

package WesternKnifePackage
{
  function Armor::onCollision(%this, %obj, %col, %vector, %speed)
  {
    if (%col.getClassName() $= "Item" && %col.canPickup && %col.getDataBlock() == nameToID("WesternKnifeItem"))
    {
      for (%i = 0; %i < %this.maxTools; %i++)
      {
        if (%obj.tool[%i] == nameToID("WesternKnifeItem") && %obj.toolAmmo[%i] < 6)
        {
          %obj.toolAmmo[%i]++;

          if (%col.isStatic())
          {
            %col.respawn();
          }
          else
          {
            %col.delete();
          }

          %obj.updateAmmoDisplay();
          return;
        }
      }
    }

    Parent::onCollision(%this, %obj, %col, %vector, %speed);
  }

  function Armor::onTrigger(%this, %obj, %slot, %state)
  {
    Parent::onTrigger(%this, %obj, %slot, %state);

    if (%slot != 4)
    {
      return;
    }

    if (%obj.tool[%obj.currTool] != nameToID("WesternKnifeItem"))
    {
      return;
    }

    if (%obj.getMountedImage(0) != nameToID("WesternKnifeImage"))
    {
      return;
    }

    %obj.setImageAmmo(0, %state);
  }
};

activatePackage("WesternKnifePackage");