addDamageType("WesternPumpShotgun", '', '%2 <Pump Shotgun W1893> %1', 0.2, 1);
addDamageType("WesternPumpShotgunHead", '', '%2 <Pump Shotgun W1893> <hat> %1', 0.2, 1);

datablock AudioProfile(WesternPumpShotgunFireSound)
{
  fileName = "./sounds_new/weapons/pumpshotgun/fire.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternPumpShotgunPumpSound1)
{
  fileName = "./sounds_new/weapons/pumpshotgun/pump1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternPumpShotgunPumpSound2)
{
  fileName = "./sounds_new/weapons/pumpshotgun/pump2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternPumpShotgunInsertSound1)
{
  fileName = "./sounds_new/weapons/pumpshotgun/reload1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternPumpShotgunInsertSound2)
{
  fileName = "./sounds_new/weapons/pumpshotgun/reload2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternPumpShotgunInsertSound3)
{
  fileName = "./sounds_new/weapons/pumpshotgun/reload3.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternPumpShotgunItem)
{
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  uiName = "Pump Shotgun W1893";
  image = WesternPumpShotgunImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;

  maxAmmo = 6;
  canReload = 1;
};

datablock ShapeBaseImageData(WesternPumpShotgunImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  item = WesternPumpShotgunItem;
  armReady = 1;

  range = 300;
  shotCount = 12;

  spread = 0.058;
  spreadMoving = 0.1;
  useSourceSpread = 1;

  directDamage = 4;
  directDamageType = $DamageType::WesternPumpShotgun;

  directHeadDamage = 8;
  directHeadDamageType = $DamageType::WesternPumpShotgunHead;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.75;
  stateTransitionOnTimeout[0] = "AmmoCheck";

  // Transitions to Ready with ImageAmmo set based on chamber
  stateName[1] = "AmmoCheck";
  stateScript[1] = "onAmmoCheck";
  stateTransitionOnTimeout[1] = "Ready";

  stateName[2] = "Ready";
  stateTransitionOnTriggerDown[2] = "Fire";
  stateTransitionOnNoAmmo[2] = "ReloadOpen";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.1;
  stateTransitionOnTimeout[3] = "Delay";
  stateEmitter[3] = WesternSmokeBurstEmitter;
  stateEmitterTime[3] = 0.3;
  stateEmitterNode[3] = "muzzleNode";

  stateName[4] = "Delay";
  stateTimeoutValue[4] = 0.15;
  stateTransitionOnTimeout[4] = "Pump";

  // Open the chamber
  stateName[5] = "ReloadOpen";
  stateScript[5] = "onReloadOpen";
  stateTimeoutValue[5] = 0.5;
  stateTransitionOnTimeout[5] = "ReloadCheck";

  // Check whether more bullets can be inserted
  stateName[6] = "ReloadCheck";
  stateScript[6] = "onReloadCheck";
  stateTimeoutValue[6] = 0.01;
  stateTransitionOnTimeout[6] = "ReloadCheckResult";

  // Either insert another bullet or close the chamber
  stateName[7] = "ReloadCheckResult";
  stateTimeoutValue[7] = 0.01;
  stateWaitForTimeout[7] = 1;
  stateTransitionOnAmmo[7] = "ReloadInsert";
  stateTransitionOnNoAmmo[7] = "ReloadClose";

  // Insert a bullet and then check again
  stateName[8] = "ReloadInsert";
  stateScript[8] = "onReloadInsert";
  stateTimeoutValue[8] = 0.7;
  stateTransitionOnTimeout[8] = "ReloadCheck";

  // Close the chamber
  stateName[9] = "ReloadClose";
  stateScript[9] = "onReloadClose";
  stateTimeoutValue[9] = 0.25;
  stateTransitionOnTimeout[9] = "Pump";

  stateName[10] = "Pump";
  stateScript[10] = "onPump";
  stateTimeoutValue[10] = 0.5;
  stateTransitionOnTimeout[10] = "AmmoCheck";
};

function WesternPumpShotgunImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  %obj.setWesternSpeed(4);
  %obj.updateAmmoDisplay();
}

function WesternPumpShotgunImage::onUnMount(%this, %obj, %slot)
{
  %obj.setWesternSpeed(0);
  %obj.updateAmmoDisplay();

  Parent::onUnMount(%this, %obj, %slot);
}

function WesternPumpShotgunImage::onReloadOpen(%this, %obj, %slot)
{
  %obj.setWesternSpeed(6);
  %obj.schedule(100, "playThread", 2, "shiftRight");
}

function WesternPumpShotgunImage::onReloadInsert(%this, %obj, %slot)
{
  %obj.playThread(2, "plant");

  %obj.toolAmmo[%obj.currTool]++;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternPumpShotgunInsertSound @ getRandom(1, 3), %obj.getMuzzlePoint(%slot));
}

function WesternPumpShotgunImage::onReloadClose(%this, %obj, %slot)
{
  %obj.setWesternSpeed(4);
  %obj.playThread(2, "shiftLeft");
}

function WesternPumpShotgunImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);
  %obj.playThread(2, "activate");

  %obj.toolAmmo[%obj.currTool]--;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternPumpShotgunFireSound, %obj.getMuzzlePoint(%slot));
}

function WesternPumpShotgunImage::onPump(%this, %obj, %slot)
{
  %obj.playThread(2, "plant");
  serverPlay3D(WesternPumpShotgunPumpSound @ getRandom(1, 2), %obj.getMuzzlePoint(%slot));
}

function WesternPumpShotgunImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage, %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}