addDamageType("WesternSawedShotgun", '', '%2 <Sawed Shotgun> %1', 0.2, 1);
addDamageType("WesternSawedShotgunHead", '', '%2 <Sawed Shotgun> <hat> %1', 0.2, 1);

datablock AudioProfile(WesternSawedShotgunFireSound)
{
  fileName = "./sounds_new/weapons/sawedshotgun/fire.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSawedShotgunOpenSound)
{
  fileName = "./sounds_new/weapons/sawedshotgun/open.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSawedShotgunCloseSound)
{
  fileName = "./sounds_new/weapons/sawedshotgun/close.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSawedShotgunExtractSound)
{
  fileName = "./sounds_new/weapons/sawedshotgun/extract.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSawedShotgunInsertSound)
{
  fileName = "./sounds_new/weapons/sawedshotgun/insert.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternSawedShotgunItem)
{
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  uiName = "Sawed Shotgun";
  image = WesternSawedShotgunImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;

  maxAmmo = 2;
  canReload = 1;
};

datablock ShapeBaseImageData(WesternSawedShotgunImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  item = WesternSawedShotgunItem;
  armReady = 1;

  range = 100;
  shotCount = 8;

  spread = 0.045;
  spreadMoving = 0.12;
  useSourceSpread = 1;

  directDamage = 3;
  directDamageType = $DamageType::WesternSawedShotgun;

  directHeadDamage = 6;
  directHeadDamageType = $DamageType::WesternSawedShotgunHead;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.75;
  stateTransitionOnTimeout[0] = "AmmoCheck";

  // Transitions to Ready with ImageAmmo set based on chamber
  stateName[1] = "AmmoCheck";
  stateScript[1] = "onAmmoCheck";
  stateTransitionOnTimeout[1] = "Ready";

  stateName[2] = "Ready";
  stateTransitionOnTriggerDown[2] = "Fire";
  stateTransitionOnNoAmmo[2] = "ReloadOpen";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.2;
  stateTransitionOnTimeout[3] = "Delay";
  stateEmitter[3] = WesternSmokeBurstEmitter;
  stateEmitterTime[3] = 0.3;
  stateEmitterNode[3] = "muzzleNode";

  stateName[4] = "Delay";
  stateTimeoutValue[4] = 0.6;
  stateTransitionOnTimeout[4] = "AmmoCheck";
  stateEmitter[4] = WesternSmokeTrailEmitter;
  stateEmitterTime[4] = 1.2;
  stateEmitterNode[4] = "muzzleNode";

  // Open the chamber
  stateName[5] = "ReloadOpen";
  stateScript[5] = "onReloadOpen";
  stateTimeoutValue[5] = 0.5;
  stateTransitionOnTimeout[5] = "ReloadExtract";

  // Remove used rounds
  stateName[6] = "ReloadExtract";
  stateScript[6] = "onReloadExtract";
  stateTimeoutValue[6] = 0.475;
  stateTransitionOnTimeout[6] = "ReloadInsert";

  // Insert both rounds
  stateName[7] = "ReloadInsert";
  stateScript[7] = "onReloadInsert";
  stateTimeoutValue[7] = 1;
  stateTransitionOnTimeout[7] = "ReloadClose";

  // Close the chamber
  stateName[8] = "ReloadClose";
  stateScript[8] = "onReloadClose";
  stateTimeoutValue[8] = 0.6;
  stateTransitionOnTimeout[8] = "AmmoCheck";
};

function WesternSawedShotgunImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  %obj.setWesternSpeed(3);
  %obj.updateAmmoDisplay();
}

function WesternSawedShotgunImage::onUnMount(%this, %obj, %slot)
{
  %obj.setWesternSpeed(0);
  %obj.updateAmmoDisplay();

  Parent::onUnMount(%this, %obj, %slot);
}

function WesternSawedShotgunImage::onReloadOpen(%this, %obj, %slot)
{
  %obj.setWesternSpeed(5);
  %obj.schedule(100, "playThread", 2, "shiftDown");

  serverPlay3D(WesternSawedShotgunOpenSound, %obj.getMuzzlePoint(%slot));
}

function WesternSawedShotgunImage::onReloadExtract(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftRight");
  serverPlay3D(WesternSawedShotgunExtractSound, %obj.getMuzzlePoint(%slot));
}

function WesternSawedShotgunImage::onReloadInsert(%this, %obj, %slot)
{
  %obj.playThread(2, "plant");

  %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternSawedShotgunInsertSound, %obj.getMuzzlePoint(%slot));
}

function WesternSawedShotgunImage::onReloadClose(%this, %obj, %slot)
{
  %obj.setWesternSpeed(3);
  %obj.playThread(2, "shiftUp");

  serverPlay3D(WesternSawedShotgunCloseSound, %obj.getMuzzlePoint(%slot));
}

function WesternSawedShotgunImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);
  %obj.playThread(2, "activate");

  %obj.toolAmmo[%obj.currTool]--;
  %obj.updateAmmoDisplay();

  serverPlay3D(WesternSawedShotgunFireSound, %obj.getMuzzlePoint(%slot));
}

function WesternSawedShotgunImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage, %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}