addDamageType("WesternSharpsRifle", '', '%2 <Sharps Rifle> %1', 0.2, 1);
addDamageType("WesternSharpsRifleHead", '', '%2 <Sharps Rifle> <hat> %1', 0.2, 1);

datablock AudioProfile(WesternSharpsRifleFireSound1)
{
  fileName = "./sounds_new/weapons/sharpsrifle/fire1.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSharpsRifleFireSound2)
{
  fileName = "./sounds_new/weapons/sharpsrifle/fire2.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSharpsRifleCockSound)
{
  fileName = "./sounds_new/weapons/sharpsrifle/cock.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSharpsRifleOpenSound)
{
  fileName = "./sounds_new/weapons/sharpsrifle/open.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSharpsRifleExtractSound)
{
  fileName = "./sounds_new/weapons/sharpsrifle/extract.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSharpsRifleInsertSound)
{
  fileName = "./sounds_new/weapons/sharpsrifle/insert.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternSharpsRifleItem)
{
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  uiName = "Sharps Rifle";
  image = WesternSharpsRifleImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;

  maxAmmo = 1;
  hideAmmo = 1;
  canReload = 1;
};

datablock ShapeBaseImageData(WesternSharpsRifleImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  item = WesternSharpsRifleItem;
  armReady = 0;

  range = 300;
  spread = 40;

  directDamage = 125;
  directDamageType = $DamageType::WesternSharpsRifle;

  directHeadDamage = 250;
  directHeadDamageType = $DamageType::WesternSharpsRifleHead;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 1.6;
  stateTransitionOnTimeout[0] = "AmmoCheck";

  // Transitions to Ready with ImageAmmo set based on chamber
  stateName[1] = "AmmoCheck";
  stateScript[1] = "onAmmoCheck";
  stateTransitionOnTimeout[1] = "Ready";

  stateName[2] = "Ready";
  stateTransitionOnTriggerDown[2] = "Fire";
  stateTransitionOnNoAmmo[2] = "ReloadOpen";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.4;
  stateTransitionOnTimeout[3] = "Delay";
  stateEmitter[3] = WesternSmokeBurstEmitter;
  stateEmitterTime[3] = 0.4;
  stateEmitterNode[3] = "muzzleNode";

  stateName[4] = "Delay";
  stateAllowImageChange[4] = 1;
  stateTimeoutValue[4] = 0.75;
  stateTransitionOnTimeout[4] = "AmmoCheck";

  // Open the chamber
  stateName[5] = "ReloadOpen";
  stateScript[5] = "onReloadOpen";
  stateTimeoutValue[5] = 0.6;
  stateTransitionOnTimeout[5] = "ReloadExtract";

  // Remove the used cartridge
  stateName[6] = "ReloadExtract";
  stateScript[6] = "onReloadExtract";
  stateTimeoutValue[6] = 1.2;
  stateTransitionOnTimeout[6] = "ReloadInsert";

  // Insert a new one
  stateName[7] = "ReloadInsert";
  stateScript[7] = "onReloadInsert";
  stateTimeoutValue[7] = 0.3;
  stateTransitionOnTimeout[7] = "ReloadClose";

  stateName[8] = "ReloadClose";
  stateScript[8] = "onReloadClose";
  stateTimeoutValue[8] = 1.5;
  stateTransitionOnTimeout[8] = "AmmoCheck";
};

datablock ShapeBaseImageData(WesternSharpsRifleScopedImage : WesternSharpsRifleImage)
{
  range = 400;
  spread = 0;

  //eyeOffset = "0 -0.08 -0.45";
  eyeOffset = "0 0.5 -0.366";

  stateSound[0] = "";
  stateTimeoutValue[0] = 0.01;

  stateTransitionOnNoAmmo[2] = "Empty";

  stateTimeoutValue[4] = 0.2;

  stateName[10] = "Empty";
  stateScript[10] = "onEmpty";
  stateTransitionOnTimeout[10] = "";
};

function WesternSharpsRifleImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  %obj.playThread(1, "root");
  %obj.schedule(850, playThread, 1, "armReadyRight");

  %obj.setWesternSpeed(4);
}

function WesternSharpsRifleImage::onUnMount(%this, %obj, %slot)
{
  %obj.playThread(1, "root");
  %obj.setWesternSpeed(0);

  Parent::onUnMount(%this, %obj, %slot);
}

function WesternSharpsRifleImage::onReloadOpen(%this, %obj, %slot)
{
  %obj.schedule(100, "playThread", 2, "shiftUp");
  %obj.setWesternSpeed(6);

  serverPlay3D(WesternSharpsRifleOpenSound, %obj.getMuzzlePoint(%slot));
}

function WesternSharpsRifleImage::onReloadExtract(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftDown");
  %obj.playThread(0, "shiftRight");

  serverPlay3D(WesternSharpsRifleExtractSound, %obj.getMuzzlePoint(%slot));
}

function WesternSharpsRifleImage::onReloadInsert(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftLeft");
  %obj.toolAmmo[%obj.currTool] = 1;

  serverPlay3D(WesternSharpsRifleInsertSound, %obj.getMuzzlePoint(%slot));
}

function WesternSharpsRifleImage::onReloadClose(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftUp");
  %obj.setWesternSpeed(4);

  serverPlay3D(WesternSharpsRifleCockSound, %obj.getMuzzlePoint(%slot));
}

function WesternSharpsRifleImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);

  %obj.playThread(2, "activate");
  %obj.toolAmmo[%obj.currTool] = 0;

  serverPlay3D(WesternSharpsRifleFireSound @ getRandom(1, 2), %obj.getMuzzlePoint(%slot));
}

function WesternSharpsRifleImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage + getRandom(-5, 5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

function WesternSharpsRifleScopedImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  if (isObject(%obj.client))
  {
    %obj.client.setControlCameraFOV(35);
  }

  %obj.setWesternSpeed(8);
}

function WesternSharpsRifleScopedImage::onUnMount(%this, %obj, %slot)
{
  if (isObject(%obj.client))
  {
    %obj.client.setControlCameraFOV(90);
  }

  %obj.setWesternSpeed(0);
  %obj.playThread(1, "root");

  Parent::onUnMount(%this, %obj, %slot);
}

function WesternSharpsRifleScopedImage::onEmpty(%this, %obj, %slot)
{
  %obj.mountImage(WesternSharpsRifleImage, %slot);
}

function WesternSharpsRifleScopedImage::onFire(%this, %obj, %slot)
{
  WesternSharpsRifleImage::onFire(%this, %obj, %slot);
}

function WesternSharpsRifleScopedImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  WesternSharpsRifleImage::damage(%this, %obj, %col, %pos, %normal, %vector);
}

package WesternSharpsRiflePackage
{
  function Armor::onTrigger(%this, %obj, %slot, %state)
  {
    Parent::onTrigger(%this, %obj, %slot, %state);

    if (%slot != 4)
    {
      return;
    }

    if (%obj.toolAmmo[%obj.currTool] < 1)
    {
      return;
    }

    %mount = %obj.getMountedImage(0);
    %name = %obj.getImageState(0);

    if (%name !$= "Ready")
    {
      return;
    }

    %a = nameToID("WesternSharpsRifleImage");
    %b = nameToID("WesternSharpsRifleScopedImage");

    if (%mount == %a && %state)
    {
      %obj.mountImage(%b, 0);
    }
    else if (%mount == %b && !%state)
    {
      %obj.mountImage(%a, 0);
    }
  }
};

activatePackage("WesternSharpsRiflePackage");