addDamageType("WesternSmithCarbine", '', '%2 <Smith Carbine> %1', 0.2, 1);
addDamageType("WesternSmithCarbineHead", '', '%2 <Smith Carbine> <hat> %1', 0.2, 1);

datablock AudioProfile(WesternSmithCarbineFireSound)
{
  fileName = "./sounds_new/weapons/smithcarbine/fire.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSmithCarbineCockSound)
{
  fileName = "./sounds_new/weapons/smithcarbine/cock.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSmithCarbineOpenSound)
{
  fileName = "./sounds_new/weapons/smithcarbine/open.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSmithCarbineCloseSound)
{
  fileName = "./sounds_new/weapons/smithcarbine/close.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSmithCarbineExtractSound)
{
  fileName = "./sounds_new/weapons/smithcarbine/extract.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock AudioProfile(WesternSmithCarbineInsertSound)
{
  fileName = "./sounds_new/weapons/smithcarbine/insert.wav";
  description = AudioDefault3D;
  preload = 1;
};

datablock ItemData(WesternSmithCarbineItem)
{
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  uiName = "Smith Carbine";
  image = WesternSmithCarbineImage;
  canDrop = 1;

  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;

  maxAmmo = 1;
  hideAmmo = 1;
  canReload = 1;
};

datablock ShapeBaseImageData(WesternSmithCarbineImage)
{
  className = "RaycastWeaponImage";
  shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";

  item = WesternSmithCarbineItem;
  armReady = 1;

  range = 100;
  spread = 8;

  directDamage = 100;
  directDamageType = $DamageType::WesternSmithCarbine;

  directHeadDamage = 140;
  directHeadDamageType = $DamageType::WesternSmithCarbineHead;

  explosion = WesternImpactProjectile;
  playerExplosion = WesternPlayerImpactProjectile;

  stateName[0] = "Activate";
  stateSound[0] = WesternWeaponSelectSound;
  stateTimeoutValue[0] = 0.75;
  stateTransitionOnTimeout[0] = "AmmoCheck";

  // Transitions to Ready with ImageAmmo set based on chamber
  stateName[1] = "AmmoCheck";
  stateScript[1] = "onAmmoCheck";
  stateTransitionOnTimeout[1] = "Ready";

  stateName[2] = "Ready";
  stateTransitionOnTriggerDown[2] = "Fire";
  stateTransitionOnNoAmmo[2] = "ReloadOpen";

  stateName[3] = "Fire";
  stateFire[3] = 1;
  stateScript[3] = "onFire";
  stateTimeoutValue[3] = 0.3;
  stateTransitionOnTimeout[3] = "Delay";
  stateEmitter[3] = WesternSmokeBurstEmitter;
  stateEmitterTime[3] = 0.3;
  stateEmitterNode[3] = "muzzleNode";

  stateName[4] = "Delay";
  stateAllowImageChange[4] = 1;
  stateTimeoutValue[4] = 0.6;
  stateTransitionOnTimeout[4] = "AmmoCheck";
  stateEmitter[4] = WesternSmokeTrailEmitter;
  stateEmitterTime[4] = 1.2;
  stateEmitterNode[4] = "muzzleNode";

  // Open the chamber
  stateName[5] = "ReloadOpen";
  stateScript[5] = "onReloadOpen";
  stateTimeoutValue[5] = 0.8;
  stateTransitionOnTimeout[5] = "ReloadExtract";

  // Remove the used cartridge
  stateName[6] = "ReloadExtract";
  stateScript[6] = "onReloadExtract";
  stateTimeoutValue[6] = 0.5;
  stateTransitionOnTimeout[6] = "ReloadInsert";

  // Insert a new one
  stateName[7] = "ReloadInsert";
  stateScript[7] = "onReloadInsert";
  stateTimeoutValue[7] = 0.75;
  stateTransitionOnTimeout[7] = "ReloadClose";

  // No more bullets can fit, close chamber, then spin+cock
  stateName[8] = "ReloadClose";
  stateScript[8] = "onReloadClose";
  stateTimeoutValue[8] = 0.5;
  stateTransitionOnTimeout[8] = "ReloadCock";

  stateName[9] = "ReloadCock";
  stateScript[9] = "onReloadCock";
  stateTimeoutValue[9] = 0.35;
  stateTransitionOnTimeout[9] = "AmmoCheck";
};

datablock ShapeBaseImageData(WesternSmithCarbineScopedImage : WesternSmithCarbineImage)
{
  range = 400;
  spread = 0.1;

  //eyeOffset = "0 -0.08 -0.45";
  eyeOffset = "0 0.5 -0.366";

  stateSound[0] = "";
  stateTimeoutValue[0] = 0.01;

  stateTransitionOnNoAmmo[2] = "Empty";

  stateTimeoutValue[4] = 0.2;

  stateName[10] = "Empty";
  stateScript[10] = "onEmpty";
  stateTransitionOnTimeout[10] = "";
};

function WesternSmithCarbineImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);
  %obj.setWesternSpeed(3);
}

function WesternSmithCarbineImage::onUnMount(%this, %obj, %slot)
{
  Parent::onUnMount(%this, %obj, %slot);
  %obj.setWesternSpeed(0);
}

function WesternSmithCarbineImage::onReloadOpen(%this, %obj, %slot)
{
  %obj.schedule(100, "playThread", 2, "shiftDown");
  %obj.setWesternSpeed(6);
  serverPlay3D(WesternSmithCarbineOpenSound, %obj.getMuzzlePoint(%slot));
}

function WesternSmithCarbineImage::onReloadExtract(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftLeft");
  serverPlay3D(WesternSmithCarbineExtractSound, %obj.getMuzzlePoint(%slot));
}

function WesternSmithCarbineImage::onReloadInsert(%this, %obj, %slot)
{
  %obj.playThread(2, "plant");
  %obj.toolAmmo[%obj.currTool] = 1;

  serverPlay3D(WesternSmithCarbineInsertSound, %obj.getMuzzlePoint(%slot));
}

function WesternSmithCarbineImage::onReloadClose(%this, %obj, %slot)
{
  %obj.playThread(2, "shiftUp");
  serverPlay3D(WesternSmithCarbineCloseSound, %obj.getMuzzlePoint(%slot));
}

function WesternSmithCarbineImage::onReloadCock(%this, %obj, %slot)
{
  //%obj.playThread(2, "plant");
  %obj.setWesternSpeed(3);
  serverPlay3D(WesternSmithCarbineCockSound @ getRandom(1, 2), %obj.getMuzzlePoint(%slot));
}

function WesternSmithCarbineImage::onFire(%this, %obj, %slot)
{
  Parent::onFire(%this, %obj, %slot);

  %obj.playThread(2, "activate");
  %obj.toolAmmo[%obj.currTool] = 0;

  serverPlay3D(WesternSmithCarbineFireSound, %obj.getMuzzlePoint(%slot));
}

function WesternSmithCarbineImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  %damage = %this.directDamage;
  %type = %this.directDamageType;

  if (%col.isHeadHit(%pos))
  {
    %damage = %this.directHeadDamage;
    %type = %this.directHeadDamageType;
  }

  %col.damage(%obj, %pos, %damage + getRandom(-5, 5), %type);

  if (%this.impactImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%vector, %this.impactImpulse));
  }

  if (%this.verticalImpulse)
  {
    %col.applyImpulse(%pos, vectorScale(%col.getUpVector(), %this.verticalImpulse));
  }
}

function WesternSmithCarbineScopedImage::onMount(%this, %obj, %slot)
{
  Parent::onMount(%this, %obj, %slot);

  if (isObject(%obj.client))
  {
    %obj.client.setControlCameraFOV(45);
  }

  %obj.setWesternSpeed(7);
}

function WesternSmithCarbineScopedImage::onUnMount(%this, %obj, %slot)
{
  if (isObject(%obj.client))
  {
    %obj.client.setControlCameraFOV(90);
  }

  %obj.setWesternSpeed(0);
  Parent::onUnMount(%this, %obj, %slot);
}

function WesternSmithCarbineScopedImage::onEmpty(%this, %obj, %slot)
{
  %obj.mountImage(WesternSmithCarbineImage, %slot);
}

function WesternSmithCarbineScopedImage::onFire(%this, %obj, %slot)
{
  WesternSmithCarbineImage::onFire(%this, %obj, %slot);
}

function WesternSmithCarbineScopedImage::damage(%this, %obj, %col, %pos, %normal, %vector)
{
  WesternSmithCarbineImage::damage(%this, %obj, %col, %pos, %normal, %vector);
}

package WesternSmithCarbinePackage
{
  function Armor::onTrigger(%this, %obj, %slot, %state)
  {
    Parent::onTrigger(%this, %obj, %slot, %state);

    if (%slot != 4)
    {
      return;
    }

    if (%obj.toolAmmo[%obj.currTool] < 1)
    {
      return;
    }

    %mount = %obj.getMountedImage(0);
    %name = %obj.getImageState(0);

    if (%name !$= "Ready")
    {
      return;
    }

    %a = nameToID("WesternSmithCarbineImage");
    %b = nameToID("WesternSmithCarbineScopedImage");

    if (%mount == %a && %state)
    {
      %obj.mountImage(%b, 0);
    }
    else if (%mount == %b && !%state)
    {
      %obj.mountImage(%a, 0);
    }
  }
};

activatePackage("WesternSmithCarbinePackage");