// Burst of smoke
datablock ParticleData(WesternSmokeBurstParticle)
{
  dragCoefficient      = 4;
  gravityCoefficient   = -0.1;
  inheritedVelFactor   = 0.2;
  constantAcceleration = 0.0;
  lifetimeMS           = 3600;
  lifetimeVarianceMS   = 200;
  textureName          = "base/data/particles/cloud";
  spinSpeed   = 10.0;
  spinRandomMin   = -50.0;
  spinRandomMax   = 50.0;

  colors[0]     = "0.75 0.75 0.75 0.35";
  colors[1]     = "0.75 0.75 0.75 0.0";
  sizes[0]      = 0.8;
  sizes[1]      = 3.6;

  useInvAlpha = true;
};

datablock ParticleEmitterData(WesternSmokeBurstEmitter)
{
   lifeTimeMS = 9;
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 6;
   velocityVariance = 1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WesternSmokeBurstParticle";
};

// Trail of smoke
datablock ParticleData(WesternSmokeTrailParticle)
{
  dragCoefficient      = 2;
  gravityCoefficient   = -0.25;
  inheritedVelFactor   = 0.2;
  constantAcceleration = 0.0;
  lifetimeMS           = 3000;
  lifetimeVarianceMS   = 200;

  spinSpeed   = 10.0;
  spinRandomMin   = -50.0;
  spinRandomMax   = 50.0;

  times[0] = 0;
  times[1] = 0.3;
  times[2] = 1;

  colors[0] = "0.85 0.85 0.85 0.03";
  colors[1] = "0.85 0.85 0.85 0.08";
  colors[2] = "0.85 0.85 0.85 0";

  sizes[0] = 0.035;
  sizes[1] = 0.035;
  sizes[2] = 0;

  textureName = "base/data/particles/cloud";
  useInvAlpha = 0;
};

datablock ParticleEmitterData(WesternSmokeTrailEmitter)
{
   lifeTimeMS = 900;
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.02;
   velocityVariance = 0.005;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WesternSmokeTrailParticle";
};

// Explosion effects
datablock ParticleData(WesternExplosionParticle)
{
  dragCoefficient      = 8;
  gravityCoefficient   = -0.1;
  inheritedVelFactor   = 0.2;
  constantAcceleration = 0.0;
  lifetimeMS           = 5000;
  lifetimeVarianceMS   = 500;
  textureName          = "base/data/particles/cloud";
  spinSpeed   = 10.0;
  spinRandomMin   = -50.0;
  spinRandomMax   = 50.0;
  colors[0]     = "0.6 0.6 0.6 0.8";
  colors[1]     = "0.5 0.5 0.5 0.0";
  sizes[0]      = 0.75;
  sizes[1]      = 2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(WesternExplosionEmitter)
{
   lifeTimeMS   = 30;
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WesternExplosionParticle";
};

datablock ParticleData(WesternExplosionParticle)
{
  dragCoefficient      = 8;
  gravityCoefficient   = -0.1;
  inheritedVelFactor   = 0.2;
  constantAcceleration = 0.0;
  lifetimeMS           = 5000;
  lifetimeVarianceMS   = 500;
  textureName          = "base/data/particles/cloud";
  spinSpeed   = 10.0;
  spinRandomMin   = -50.0;
  spinRandomMax   = 50.0;
  colors[0]     = "0.6 0.6 0.6 0.8";
  colors[1]     = "0.5 0.5 0.5 0.0";
  sizes[0]      = 0.75;
  sizes[1]      = 2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(WesternExplosionEmitter)
{
   lifeTimeMS   = 30;
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WesternExplosionParticle";
};

datablock ParticleData(WesternExplosion2Particle)
{
  dragCoefficient      = 0;
  gravityCoefficient   = 5.0;
  inheritedVelFactor   = 0.0;
  constantAcceleration = 0.0;
  lifetimeMS           = 100;
  lifetimeVarianceMS   = 60;
  textureName          = "base/data/particles/chunk";
  spinSpeed   = 10.0;
  spinRandomMin   = -500.0;
  spinRandomMax   = 500.0;
  colors[0]     = "0.01 0.01 0.01 0.9";
  colors[1]     = "0.01 0.01 0.01 0.6";
  sizes[0]      = 0.1;
  sizes[1]      = 0.1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(WesternExplosion2Emitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 2;
   ejectionVelocity = 15;
   velocityVariance = 2;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WesternExplosion2Particle";
};

datablock ParticleData(WesternBloodExplosion2Particle)
{
  dragCoefficient      = 0;
  gravityCoefficient   = 5.0;
  inheritedVelFactor   = 0.0;
  constantAcceleration = 0.0;
  lifetimeMS           = 100;
  lifetimeVarianceMS   = 60;
  textureName          = "base/data/particles/chunk";
  spinSpeed   = 10.0;
  spinRandomMin   = -500.0;
  spinRandomMax   = 500.0;
  colors[0]     = "0.71 0.01 0.01 0.9";
  colors[1]     = "0.71 0.01 0.01 0.6";
  sizes[0]      = 0.1;
  sizes[1]      = 0.1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(WesternBloodExplosion2Emitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 2;
   ejectionVelocity = 4;
   velocityVariance = 2;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WesternBloodExplosion2Particle";
};

datablock ExplosionData(WesternImpactExplosion)
{
  lifeTimeMS = 150;
  particleEmitter = WesternExplosionEmitter;
  particleDensity = 5;
  particleRadius = 0.2;
  emitter[0] = WesternExplosion2Emitter;
  faceViewer     = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "0.0 1.0 1.0";
  camShakeAmp = "0.0 1.0 1.5";
  camShakeDuration = 0.5;
  camShakeRadius = 0.5;
  lightStartRadius = 0;
  lightEndRadius = 0;
};

datablock ExplosionData(WesternPlayerImpactExplosion)
{
  lifeTimeMS = 150;
  particleEmitter = WesternBloodExplosion2Emitter;
  particleDensity = 5;
  particleRadius = 0.2;
  faceViewer     = true;
  explosionScale = "1 1 1";
  shakeCamera = false;
  camShakeFreq = "0.0 1.0 1.0";
  camShakeAmp = "0.0 3.0 2.5";
  camShakeDuration = 0.5;
  camShakeRadius = 0.5;
  lightStartRadius = 0;
  lightEndRadius = 0;
};

datablock ProjectileData(WesternImpactProjectile)
{
  explosion = WesternImpactExplosion;
};

datablock ProjectileData(WesternPlayerImpactProjectile)
{
  explosion = WesternPlayerImpactExplosion;
};