datablock AudioProfile(WesternWeaponSelectSound)
{
  fileName = "./sounds_new/common/wpn_select.wav";
  description = AudioDefault3D;
  preload = 1;
};

function Player::isHeadHit(%this, %pos)
{
  if (%this.isCrouched())
  {
    return 1;
  }

  %subtract = 3.3 * getWord(%this.getScale(), 2);
  %minimum = getWord(%this.getWorldBoxCenter(), 2) - %subtract;

  return getWord(%pos, 2) > %minimum;
}

exec("./Support_Raycasting.cs");
exec("./Support_WeaponAmmo.cs");

exec("./datablocks.cs");
exec("./damage.cs");
exec("./players.cs");

exec("./Weapon_Fists.cs");
exec("./Weapon_Knife.cs");
exec("./Weapon_Hatchet.cs");
exec("./Weapon_Colt_Navy.cs");
exec("./Weapon_Sawed_Shotgun.cs");
exec("./Weapon_Smith_Carbine.cs");
exec("./Weapon_Pump_Shotgun.cs");
exec("./Weapon_Colt_Walker.cs");
exec("./Weapon_Sharps_Rifle.cs");

function Player::updateAmmoDisplay(%this)
{
  %client = %this.client;

  if (!isObject(%client))
  {
    return;
  }

  %max = %this.tool[%this.currTool].maxAmmo;
  %cur = %this.toolAmmo[%this.currTool];

  %text = "<just:right><font:lucida console:48>\c6";

  if (!%this.tool[%this.currTool].hideAmmo)
  {
    for (%i = 0; %i < %this.toolAmmo[%this.currTool]; %i++)
    {
      //%text = %text @ "";
      %text = %text @ "o";
    }

    %text = %text @ "<color:75330e>";

    for (%i; %i < %this.tool[%this.currTool].maxAmmo; %i++)
    {
      %text = %text @ "";
      //%text = %text @ "o";
    }
  }

  // for (%i = 0; %i < %max; %i++)
  // {
  //   //%text = %text @ (%cur > %i ? "" : ".");
  //   //%text = %text @ (%cur > %i ? "" : "o");
  //   %text = %text @ (%cur > %i ? "\c6" : "<color:594132>");
  // }

  %client.bottomPrint(%text @ " \n", 0, 1);
}

function d()
{
  cancel($d);
  %player = findLocalClient().player;

  if (isObject(%player))
  {
    clientCmdBottomPrint("\c6" @ %player.getImageState(0), "\n", 1, 1);
  }

  $d = schedule(0, 0, "d");
}

package oo
{
  function Armor::onDisabled(%this, %obj, %state)
  {
    if (isObject(%obj.client))
    {
      serverCmdDropTool(%obj.client, %obj.currTool);
    }

    Parent::onDisabled(%this, %obj, %state);
  }

  function Player::mountImage(%this, %image, %slot)
  {
    // if (%slot == 0)
    // {
    //   cancel(%this.mountSchedule);
    // }

    Parent::mountImage(%this, %image, %slot);
  }

  function Player::unMountImage(%this, %slot)
  {
    Parent::unMountImage(%this, %slot);

    // if (%slot == 0)
    // {
    //   %this.mountSchedule = %this.schedule(2000, mountImage, WesternFistsImage, 0);
    // }
  }
};

activatePackage("oo");

$DefaultMiniGame.startEquip0 = nameToID("WesternKnifeItem");
$DefaultMiniGame.startEquip1 = nameToID("WesternHatchetItem");
$DefaultMiniGame.startEquip2 = nameToID("WesternColtNavyItem");
$DefaultMiniGame.startEquip3 = nameToID("WesternSawedShotgunItem");
$DefaultMiniGame.startEquip4 = nameToID("WesternSmithCarbineItem");